-- Object methods
-- Since: v0.3.3b
local obj = {}

--[[
function obj.GetObjPos(obj)
	local x = 0
	local y = 0
	local z = 0
	if (obj ~= 0) then
		local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
		x = ReadProcessMemory(obj_sprite_ptr + 0x14, 4) / 16384
		y = ReadProcessMemory(obj_sprite_ptr + 0x18, 4) / 16384
		z = ReadProcessMemory(obj_sprite_ptr + 0x1C, 4) / 16384
	end
	return x, y, z
end

function obj.GetObjAngle(obj)
	local rotation = 0
	if (obj ~= 0) then
		local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
		rotation = 360 * ReadProcessMemory(obj_sprite_ptr, 4) / 1439;
	end
	return rotation
end

function obj.GetObjModel(obj)
	local obj_model = 0
	if (model >= 0 and model <= 65535) then
		if (obj ~= nil) then
			obj_model = ReadProcessMemory(obj + 0x18, 2)
		end
	end
	return obj_model
end

function obj.SetObjAngle(obj, angle)
	if (obj ~= 0) then
		local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
		WriteProcessMemory(obj_sprite_ptr, angle * 1439 / 360, 4)
	end
end

-- Work only z need obj sprite pointer?
function obj.SetObjPos(obj, x, y, z)
	if (x >= 0 and x <= 255 and y >= 0 and y < 255 and z >= 0 and z <= 255) then
		if (obj ~= 0) then
			local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
			WriteProcessMemory(obj_sprite_ptr + 0x14, x * 16384, 4)
			WriteProcessMemory(obj_sprite_ptr + 0x18, y * 16384, 4)
			WriteProcessMemory(obj_sprite_ptr + 0x1C, z * 16384, 4)
		end
	end
end
]]--

function obj.GetObjSpriteID(obj)
	local obj_spriteid = 0
	if (obj ~= 0) then
		local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
		obj_spriteid = ReadProcessMemory(obj_sprite_ptr + 0x22, 2)
	end
	return obj_spriteid
end

function obj.SetObjSpriteID(obj, spriteid)
	if (spriteid >= 0 and spriteid <= 65535) then
		if (obj ~= 0) then
			local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
			WriteProcessMemory(obj_sprite_ptr + 0x22, spriteid, 2) -- sprite id?
		end
	end
end

return obj